<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "practice".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Practice".
 *
 * Columns in table "practice" available as properties of the model,
 * followed by relations of table "practice" available as properties of the model.
 *
 * @property integer $id
 * @property integer $localization_id
 * @property integer $country_id
 * @property integer $unpublished
 * @property integer $is_test
 * @property string $name
 * @property string $listing_name_override
 * @property integer $practice_group_id
 * @property integer $health_system_id
 * @property string $address_full
 * @property string $address
 * @property string $address_2
 * @property integer $location_id
 * @property double $latitude
 * @property double $longitude
 * @property string $phone_number
 * @property string $fax_number
 * @property string $email
 * @property string $website
 * @property integer $handicap_accesible
 * @property integer $aesthetic_procedure
 * @property string $description
 * @property string $friendly_url
 * @property integer $visits_number
 * @property integer $parent_practice_id
 * @property string $logo_path
 * @property string $date_added
 * @property string $date_updated
 * @property string $date_umd_updated
 * @property string $phone_number_clean
 * @property integer $out_of_network
 * @property integer $facility_fee
 * @property string $npi_id
 * @property integer $yelp_sync_approved
 * @property string $yext_location_id
 * @property string $yelp_business_id
 * @property string $dme_services
 * @property integer $score
 * @property string $nasp_date
 * @property integer $claimed
 *
 * @property AccountContactSetting[] $accountContactSettings
 * @property AccountDevice[] $accountDevices
 * @property AccountPractice[] $accountPractices
 * @property OrganizationFeature[] $organizationFeatures
 * @property OrganizationHistory[] $organizationHistories
 * @property PartnerSiteParams[] $partnerSiteParams
 * @property Patientemail[] $patientemails
 * @property Location $location
 * @property PracticeGroup $practiceGroup
 * @property BasePractice $parentPractice
 * @property BasePractice[] $practices
 * @property HealthSystem $healthSystem
 * @property PracticeDetails $practiceDetails
 * @property PracticeLanguage[] $practiceLanguages
 * @property PracticeOfficeHour[] $practiceOfficeHours
 * @property PracticePatient[] $practicePatients
 * @property PracticePhoto[] $practicePhotos
 * @property PracticeSpecialty[] $practiceSpecialties
 * @property PracticeTreatment[] $practiceTreatments
 * @property PracticeUrlHistory[] $practiceUrlHistories
 * @property PracticeVideo[] $practiceVideos
 * @property ProviderHospital[] $providerHospitals
 * @property ProviderPractice[] $providerPractices
 * @property ProviderPracticeListing[] $providerPracticeListings
 * @property ProviderPracticeWidget[] $providerPracticeWidgets
 * @property ProviderRating[] $providerRatings
 * @property ProviderTreatmentPerformed[] $providerTreatmentPerformeds
 * @property QualityPath[] $qualityPaths
 * @property ReviewRequest[] $reviewRequests
 * @property Scan[] $scans
 * @property TwilioNumber[] $twilioNumbers
 */
abstract class BasePractice extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'practice';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Practice|Practices', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array(
                'name, friendly_url, score',
                'required'
            ),
            array(
                'localization_id, country_id, unpublished, is_test, practice_group_id,  health_system_id, location_id,
                handicap_accesible, aesthetic_procedure, visits_number, parent_practice_id, out_of_network,
                facility_fee, yelp_sync_approved, score, claimed',
                'numerical',
                'integerOnly' => true
            ),
            array(
                'latitude, longitude',
                'numerical'
            ),
            array(
                'name, listing_name_override',
                'length',
                'max' => 150
            ),
            array(
                'address_full',
                'length',
                'max' => 160
            ),
            array(
                'address, address_2',
                'length',
                'max' => 80
            ),
            array(
                'phone_number, fax_number, phone_number_clean',
                'length',
                'max' => 14
            ),
            array(
                'email',
                'length',
                'max' => 254
            ),
            array(
                'website, friendly_url, logo_path',
                'length',
                'max' => 255
            ),
            array(
                'npi_id',
                'length',
                'max' => 10
            ),
            array(
                'yext_location_id',
                'length',
                'max' => 20
            ),
            array(
                'yelp_business_id',
                'length',
                'max' => 22
            ),
            array(
                'dme_services',
                'length',
                'max' => 100
            ),
            array(
                'description, date_added, date_updated, date_umd_updated',
                'safe'
            ),
            array('nasp_date, claimed', 'default', 'setOnEmpty' => true, 'value' => null),
            array(
                'id, localization_id, country_id, unpublished, is_test, name, practice_group_id, health_system_id,
                address_full, address, address_2, location_id, latitude, longitude, phone_number, fax_number, email,
                website, handicap_accesible, aesthetic_procedure, description, friendly_url, visits_number,
                parent_practice_id, logo_path, date_added, date_updated, date_umd_updated, phone_number_clean,
                out_of_network, facility_fee, npi_id, yelp_sync_approved, yext_location_id, yelp_business_id,
                dme_services, score, nasp_date, claimed, listing_name_override',
                'safe',
                'on' => 'search'
            )
        );
    }

    public function relations()
    {
        return array(
            'accountContactSettings' => array(
                self::HAS_MANY,
                'AccountContactSetting',
                'practice_id'
            ),
            'accountDevices' => array(
                self::HAS_MANY,
                'AccountDevice',
                'practice_id'
            ),
            'accountPractices' => array(
                self::HAS_MANY,
                'AccountPractice',
                'practice_id'
            ),
            'organizationFeatures' => array(
                self::HAS_MANY,
                'OrganizationFeature',
                'practice_id'
            ),
            'organizationHistories' => array(
                self::HAS_MANY,
                'OrganizationHistory',
                'practice_id'
            ),
            'partnerSiteParams' => array(
                self::HAS_MANY,
                'PartnerSiteParams',
                'practice_id'
            ),
            'patientemails' => array(
                self::HAS_MANY,
                'Patientemail',
                'practice_id'
            ),
            'location' => array(
                self::BELONGS_TO,
                'Location',
                'location_id'
            ),
            'practiceGroup' => array(
                self::BELONGS_TO,
                'PracticeGroup',
                'practice_group_id'
            ),
            'parentPractice' => array(
                self::BELONGS_TO,
                'Practice',
                'parent_practice_id'
            ),
            'practices' => array(
                self::HAS_MANY,
                'Practice',
                'parent_practice_id'
            ),
            'healthSystem' => array(
                self::BELONGS_TO,
                'HealthSystem',
                'health_system_id'
            ),
            'practiceDetails' => array(
                self::HAS_ONE,
                'PracticeDetails',
                'practice_id'
            ),
            'practiceLanguages' => array(
                self::HAS_MANY,
                'PracticeLanguage',
                'practice_id'
            ),
            'practiceOfficeHours' => array(
                self::HAS_MANY,
                'PracticeOfficeHour',
                'practice_id'
            ),
            'practicePatients' => array(
                self::HAS_MANY,
                'PracticePatient',
                'practice_id'
            ),
            'practicePhotos' => array(
                self::HAS_MANY,
                'PracticePhoto',
                'practice_id'
            ),
            'practiceSpecialties' => array(
                self::HAS_MANY,
                'PracticeSpecialty',
                'practice_id'
            ),
            'practiceTreatments' => array(
                self::HAS_MANY,
                'PracticeTreatment',
                'practice_id'
            ),
            'practiceUrlHistories' => array(
                self::HAS_MANY,
                'PracticeUrlHistory',
                'practice_id'
            ),
            'practiceVideos' => array(
                self::HAS_MANY,
                'PracticeVideo',
                'practice_id'
            ),
            'providerHospitals' => array(
                self::HAS_MANY,
                'ProviderHospital',
                'practice_id'
            ),
            'providerPractices' => array(
                self::HAS_MANY,
                'ProviderPractice',
                'practice_id'
            ),
            'providerPracticeListings' => array(
                self::HAS_MANY,
                'ProviderPracticeListing',
                'practice_id'
            ),
            'providerPracticeWidgets' => array(
                self::HAS_MANY,
                'ProviderPracticeWidget',
                'practice_id'
            ),
            'providerRatings' => array(
                self::HAS_MANY,
                'ProviderRating',
                'practice_id'
            ),
            'providerTreatmentPerformeds' => array(
                self::HAS_MANY,
                'ProviderTreatmentPerformed',
                'practice_id'
            ),
            'qualityPaths' => array(
                self::HAS_MANY,
                'QualityPath',
                'practice_id'
            ),
            'reviewRequests' => array(
                self::HAS_MANY,
                'ReviewRequest',
                'practice_id'
            ),
            'scans' => array(
                self::HAS_MANY,
                'Scan',
                'practice_id'
            ),
            'twilioNumbers' => array(
                self::HAS_MANY,
                'TwilioNumber',
                'practice_id'
            )
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'localization_id' => Yii::t('app', 'Localization'),
            'country_id' => Yii::t('app', 'Country'),
            'unpublished' => Yii::t('app', 'Unpublished'),
            'is_test' => Yii::t('app', 'Is Test'),
            'name' => Yii::t('app', 'Name'),
            'listing_name_override' => Yii::t('app', 'Listing Name Override'),
            'practice_group_id' => null,
            'health_system_id' => Yii::t('app', 'Health System'),
            'address_full' => Yii::t('app', 'Address Full'),
            'address' => Yii::t('app', 'Address'),
            'address_2' => Yii::t('app', 'Address 2'),
            'location_id' => null,
            'latitude' => Yii::t('app', 'Latitude'),
            'longitude' => Yii::t('app', 'Longitude'),
            'phone_number' => Yii::t('app', 'Phone Number'),
            'fax_number' => Yii::t('app', 'Fax Number'),
            'email' => Yii::t('app', 'Email'),
            'website' => Yii::t('app', 'Website'),
            'handicap_accesible' => Yii::t('app', 'Handicap Accesible'),
            'aesthetic_procedure' => Yii::t('app', 'Aesthetic Procedures Complete'),
            'description' => Yii::t('app', 'Description'),
            'friendly_url' => Yii::t('app', 'Friendly Url'),
            'visits_number' => Yii::t('app', 'Visits Number'),
            'parent_practice_id' => Yii::t('app', 'Parent Practice'),
            'logo_path' => Yii::t('app', 'Logo Path'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'date_umd_updated' => Yii::t('app', 'Date Umd Updated'),
            'phone_number_clean' => Yii::t('app', 'Phone Number Clean'),
            'out_of_network' => Yii::t('app', 'Out Of Network'),
            'facility_fee' => Yii::t('app', 'Facility Fee'),
            'npi_id' => Yii::t('app', 'Npi'),
            'yext_location_id' => Yii::t('app', 'Yext Location'),
            'dme_services' => Yii::t('app', 'Dme Services'),
            'score' => Yii::t('app', 'Score'),
            'nasp_date' => Yii::t('app', 'Nasp Date'),
            'claimed' => Yii::t('app', 'Claimed'),
            'accountDevices' => null,
            'accountPractices' => null,
            'organizationFeatures' => null,
            'organizationHistories' => null,
            'location' => null,
            'practiceGroup' => null,
            'country' => null,
            'localization' => null,
            'practiceDetails' => null,
            'practiceLanguages' => null,
            'practiceOfficeHours' => null,
            'practicePatients' => null,
            'practicePhotos' => null,
            'practiceSpecialties' => null,
            'practiceTreatments' => null,
            'practiceUrlHistories' => null,
            'practiceVideos' => null,
            'providerHospitals' => null,
            'providerPractices' => null,
            'providerPracticeInsurances' => null,
            'providerPracticeListings' => null,
            'providerPracticeWidgets' => null,
            'providerRatings' => null,
            'providerTreatmentPerformeds' => null,
            'qualityPaths' => null,
            'reviewRequests' => null,
            'twilioNumbers' => null
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria();

        $criteria->compare('id', $this->id);
        $criteria->compare('localization_id', $this->localization_id);
        $criteria->compare('country_id', $this->country_id);
        $criteria->compare('unpublished', $this->unpublished);
        $criteria->compare('is_test', $this->is_test);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('listing_name_override', $this->listing_name_override, true);
        $criteria->compare('practice_group_id', $this->practice_group_id);
        $criteria->compare('health_system_id', $this->health_system_id);
        $criteria->compare('address_full', $this->address_full, true);
        $criteria->compare('address', $this->address, true);
        $criteria->compare('address_2', $this->address_2, true);
        $criteria->compare('location_id', $this->location_id);
        $criteria->compare('latitude', $this->latitude);
        $criteria->compare('longitude', $this->longitude);
        $criteria->compare('phone_number', $this->phone_number, true);
        $criteria->compare('fax_number', $this->fax_number, true);
        $criteria->compare('email', $this->email, true);
        $criteria->compare('website', $this->website, true);
        $criteria->compare('handicap_accesible', $this->handicap_accesible);
        $criteria->compare('aesthetic_procedure', $this->aesthetic_procedure);
        $criteria->compare('description', $this->description, true);
        $criteria->compare('friendly_url', $this->friendly_url, true);
        $criteria->compare('visits_number', $this->visits_number);
        $criteria->compare('parent_practice_id', $this->parent_practice_id);
        $criteria->compare('logo_path', $this->logo_path, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('date_umd_updated', $this->date_umd_updated, true);
        $criteria->compare('phone_number_clean', $this->phone_number_clean, true);
        $criteria->compare('out_of_network', $this->out_of_network);
        $criteria->compare('facility_fee', $this->facility_fee);
        $criteria->compare('npi_id', $this->npi_id, true);
        $criteria->compare('yelp_sync_approved', $this->yelp_sync_approved);
        $criteria->compare('yext_location_id', $this->yext_location_id, true);
        $criteria->compare('yelp_business_id', $this->yelp_business_id, true);
        $criteria->compare('dme_services', $this->dme_services, true);
        $criteria->compare('claimed', $this->claimed);
        $criteria->compare('score', $this->score);

        return new CActiveDataProvider(get_class($this), array(
            'criteria' => $criteria,
            'pagination' => array(
                'pageSize' => 100
            )
        ));
    }

}
